#!/usr/bin/env python

"""
This test attempts to cause the recording of the usage of 'C' in the function
'g', alongside the expectation that 'D' might be used instead. A guard
stipulating constraints for all of 'g' cannot therefore be generated.
"""

class C:
    def f(self):
        return 0

class D:
    def f(self):
        return 1

    def g(self):
        return 2

    def h(self):
        return 3

def g(c):
    if 1:
        c.g()
        if 1:
            return c.h()
    return c.f()

c = C()
d = D()
result1_3 = g(d)

# vim: tabstop=4 expandtab shiftwidth=4
